var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { createPortal } from 'react-dom';

if (!window._seeds_lang) window._seeds_lang = {}; // 国际化数据

var Actionsheet = (_temp = _class = function (_Component) {
  _inherits(Actionsheet, _Component);

  function Actionsheet(props) {
    _classCallCheck(this, Actionsheet);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.componentDidMount = function () {};

    _this.onClick = function (e) {
      var item = null;
      var index = null;
      if (e.target.classList.contains('actionsheet-option')) {
        index = target.getAttribute('data-index');
        index = Number(index);
        item = _this.props.list[index] || null;
      }
      if (_this.props.onClick) {
        _this.props.onClick(e, item, index);
        e.stopPropagation();
      }
    };

    return _this;
  }

  Actionsheet.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        portal = _props.portal,
        show = _props.show,
        list = _props.list,
        _props$maskAttribute = _props.maskAttribute,
        maskAttribute = _props$maskAttribute === undefined ? {} : _props$maskAttribute,
        _props$groupAttribute = _props.groupAttribute,
        groupAttribute = _props$groupAttribute === undefined ? {} : _props$groupAttribute,
        _props$optionAttribut = _props.optionAttribute,
        optionAttribute = _props$optionAttribut === undefined ? {} : _props$optionAttribut,
        cancelCaption = _props.cancelCaption,
        _props$cancelAttribut = _props.cancelAttribute,
        cancelAttribute = _props$cancelAttribut === undefined ? {} : _props$cancelAttribut,
        onClick = _props.onClick,
        others = _objectWithoutProperties(_props, ['portal', 'show', 'list', 'maskAttribute', 'groupAttribute', 'optionAttribute', 'cancelCaption', 'cancelAttribute', 'onClick']);

    return createPortal(React.createElement(
      'div',
      _extends({ ref: function ref(el) {
          _this2.$el = el;
        } }, maskAttribute, { className: 'mask actionsheet-mask' + (maskAttribute.className ? ' ' + maskAttribute.className : '') + (show ? ' active' : ''), onClick: this.onClick }),
      React.createElement(
        'div',
        _extends({ 'data-animation': 'slideUp' }, others, { className: 'actionsheet' + (others.className ? ' ' + others.className : '') + (show ? ' active' : '') }),
        React.createElement(
          'div',
          _extends({}, groupAttribute, { className: 'actionsheet-group' + (groupAttribute.className ? ' ' + groupAttribute.className : '') }),
          list && list.map(function (item, index) {
            return React.createElement(
              'a',
              _extends({}, optionAttribute, { className: 'actionsheet-option' + (optionAttribute.className ? ' ' + optionAttribute.className : ' border-b'), key: index, 'data-index': index }),
              item.caption
            );
          })
        ),
        cancelAttribute.onClick && React.createElement(
          'a',
          _extends({}, cancelAttribute, { className: 'actionsheet-cancel' + (cancelAttribute.className ? ' ' + cancelAttribute.className : '') }),
          cancelCaption
        )
      )
    ), portal || document.getElementById('root') || document.body);
  };

  return Actionsheet;
}(Component), _class.defaultProps = {
  cancelCaption: window._seeds_lang['cancel'] || '取消'
}, _temp);
export { Actionsheet as default };
Actionsheet.propTypes = process.env.NODE_ENV !== "production" ? {
  portal: PropTypes.object,
  show: PropTypes.bool,

  list: PropTypes.array, // [{caption: string, onClick: func}]

  maskAttribute: PropTypes.object,
  groupAttribute: PropTypes.object,
  optionAttribute: PropTypes.object,

  cancelCaption: PropTypes.node,
  cancelAttribute: PropTypes.object,

  onClick: PropTypes.func
} : {};