'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var InputText = (_temp = _class = function (_Component) {
  _inherits(InputText, _Component);

  function InputText(props) {
    _classCallCheck(this, InputText);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.componentDidUpdate = function (prevProps) {
      if (prevProps.readOnly !== _this.props.readOnly || prevProps.disabled !== _this.props.disabled) {
        _this.updateShowClear();
      }
    };

    _this.onClick = function (e) {
      e.stopPropagation();
      var _this$props = _this.props,
          onClick = _this$props.onClick,
          _this$props$inputAttr = _this$props.inputAttribute,
          inputAttribute = _this$props$inputAttr === undefined ? {} : _this$props$inputAttr,
          _this$props$liconAttr = _this$props.liconAttribute,
          liconAttribute = _this$props$liconAttr === undefined ? {} : _this$props$liconAttr,
          _this$props$riconAttr = _this$props.riconAttribute,
          riconAttribute = _this$props$riconAttr === undefined ? {} : _this$props$riconAttr;

      if (_this.props.disabled) return;
      var target = e.target;
      if (target.classList.contains('clearicon')) {
        _this.onClear(e);
      } else if (target.classList.contains('licon')) {
        if (liconAttribute.onClick) liconAttribute.onClick(e, _this.$input.value);
      } else if (target.classList.contains('ricon')) {
        if (riconAttribute.onClick) riconAttribute.onClick(e, _this.$input.value);
      } else if (target.classList.contains('input-text')) {
        if (onClick) onClick(e, _this.$input.value);
        if (inputAttribute.onClick) inputAttribute.onClick(e, _this.$input.value);
      } else {
        if (onClick) onClick(e, _this.$input.value);
      }
    };

    _this.preAutoSize = function () {
      _this.$input.style.height = _this.$pre.clientHeight + 'px';
    };

    _this.onChange = function (e) {
      var target = e.target;
      var value = target.value;
      var _this$props2 = _this.props,
          pre = _this$props2.pre,
          valueBindProp = _this$props2.valueBindProp,
          type = _this$props2.type,
          onChange = _this$props2.onChange,
          maxLength = _this$props2.maxLength;
      // 自动扩充功能

      if (pre) {
        _this.$pre.children[0].innerText = value;
        _this.preAutoSize();
      }
      // 最大长度
      if (maxLength && value && value.length > maxLength) {
        value = value.substring(0, maxLength);
      }
      // 输入时只校验最大值、小数点、最大长度、返回错误
      if (type === 'number') {
        var _this$props3 = _this.props,
            max = _this$props3.max,
            digits = _this$props3.digits,
            onError = _this$props3.onError;

        value = Math.Calc.correctNumber(e.target.value, { max: max, digits: digits, maxLength: maxLength, onError: onError });
      }
      // onChange
      if (onChange) onChange(e, value);
      // 非valueBindProp时, 更新清除按钮状态
      if (!valueBindProp) _this.updateShowClear(value);
    };

    _this.onBlur = function (e) {
      var target = e.target;
      var value = target.value;
      var _this$props4 = _this.props,
          valueBindProp = _this$props4.valueBindProp,
          min = _this$props4.min,
          type = _this$props4.type,
          onBlur = _this$props4.onBlur,
          onChange = _this$props4.onChange;

      if (type === 'number') {
        // 失去焦点时只校验非空、最小值
        value = Math.Calc.correctNumber(value, { min: min });
        if (!valueBindProp) target.value = value;
        if (onChange) onChange(e, value);
      }
      if (onBlur) onBlur(e, value);
    };

    _this.onFocus = function (e) {
      var target = e.target;
      var value = target.value;
      var _this$props5 = _this.props,
          onFocus = _this$props5.onFocus,
          readOnly = _this$props5.readOnly;

      if (onFocus) {
        onFocus(e, value);
        e.stopPropagation();
      }
      if (readOnly) {
        target.blur();
      }
    };

    _this.onClear = function (e) {
      _this.$input.focus();
      // 赋值
      var _this$props6 = _this.props,
          valueBindProp = _this$props6.valueBindProp,
          clear = _this$props6.clear,
          pre = _this$props6.pre,
          onChange = _this$props6.onChange;

      if (!valueBindProp) _this.$input.value = '';
      if (clear && typeof clear === 'function') clear(e, '');
      if (onChange) {
        onChange(e, '');
      }
      // 自动扩充功能
      if (pre) {
        _this.preAutoSize();
      }
      e.stopPropagation();
      // 非valueBindProp时, 更新清除按钮状态
      if (!valueBindProp) _this.updateShowClear('');
    };

    _this.getInputDOM = function () {
      var _this$props7 = _this.props,
          max = _this$props7.max,
          min = _this$props7.min,
          pre = _this$props7.pre,
          type = _this$props7.type,
          valueBindProp = _this$props7.valueBindProp,
          autoFocus = _this$props7.autoFocus,
          _this$props7$inputAtt = _this$props7.inputAttribute,
          inputAttribute = _this$props7$inputAtt === undefined ? {} : _this$props7$inputAtt,
          maxLength = _this$props7.maxLength,
          value = _this$props7.value,
          placeholder = _this$props7.placeholder,
          readOnly = _this$props7.readOnly,
          disabled = _this$props7.disabled;
      // pre类型

      if (pre) {
        // pre的左右padding
        var preLeft = 0;
        var preRight = 0;
        if (inputAttribute.style) {
          if (inputAttribute.style.padding) {
            var paddingValues = inputAttribute.style.padding.split(' ');
            if (paddingValues.length === 1) {
              preLeft = paddingValues[0];
              preRight = paddingValues[0];
            } else if (paddingValues.length === 2) {
              preLeft = paddingValues[1];
              preRight = paddingValues[1];
            } else if (paddingValues.length === 4) {
              preLeft = paddingValues[1];
              preRight = paddingValues[3];
            }
          } else if (inputAttribute.style.paddingLeft || inputAttribute.style.paddingRight) {
            preLeft = inputAttribute.style.paddingLeft || '0';
            preRight = inputAttribute.style.paddingRight || '0';
          }
        }
        return _react2.default.createElement(
          'div',
          _extends({}, inputAttribute, { className: 'input-pre-box' + (inputAttribute.className ? ' ' + inputAttribute.className : '') }),
          valueBindProp && _react2.default.createElement('textarea', { ref: function ref(el) {
              _this.$input = el;
            }, autoFocus: autoFocus, value: value, maxLength: maxLength, readOnly: readOnly, disabled: disabled, className: 'input-pre', placeholder: placeholder, onChange: _this.onChange, onBlur: _this.onBlur, onFocus: _this.onFocus }),
          !valueBindProp && _react2.default.createElement('textarea', { ref: function ref(el) {
              _this.$input = el;
            }, autoFocus: autoFocus, defaultValue: value, maxLength: maxLength, readOnly: readOnly, disabled: disabled, className: 'input-pre', placeholder: placeholder, onChange: _this.onChange, onBlur: _this.onBlur, onFocus: _this.onFocus }),
          _react2.default.createElement(
            'pre',
            { ref: function ref(el) {
                _this.$pre = el;
              }, style: { left: preLeft, right: preRight } },
            _react2.default.createElement(
              'span',
              null,
              value
            )
          )
        );
      }
      // textarea类型
      if (type === 'textarea') {
        // 如果值绑定属性,则只有通过父组件的prop来改变值
        if (valueBindProp) {
          return _react2.default.createElement('textarea', _extends({ ref: function ref(el) {
              _this.$input = el;
            } }, inputAttribute, { autoFocus: autoFocus, value: value, maxLength: maxLength, readOnly: readOnly, disabled: disabled, placeholder: placeholder, onChange: _this.onChange, onBlur: _this.onBlur, onFocus: _this.onFocus, className: 'input-area' + (inputAttribute.className ? ' ' + inputAttribute.className : '') }));
        }
        return _react2.default.createElement('textarea', _extends({ ref: function ref(el) {
            _this.$input = el;
          } }, inputAttribute, { autoFocus: autoFocus, defaultValue: value, maxLength: maxLength, readOnly: readOnly, disabled: disabled, placeholder: placeholder, onChange: _this.onChange, onBlur: _this.onBlur, onFocus: _this.onFocus, className: 'input-area' + (inputAttribute.className ? ' ' + inputAttribute.className : '') }));
      }
      // 其它类型
      if (valueBindProp) {
        // 如果值绑定属性,则只有通过父组件的prop来改变值
        return _react2.default.createElement('input', _extends({ ref: function ref(el) {
            _this.$input = el;
          } }, inputAttribute, { max: max, min: min, autoFocus: autoFocus, type: type, value: value, maxLength: maxLength, readOnly: readOnly, disabled: disabled, placeholder: placeholder, onChange: _this.onChange, onBlur: _this.onBlur, onFocus: _this.onFocus, className: 'input-text' + (inputAttribute.className ? ' ' + inputAttribute.className : '') }));
      }
      return _react2.default.createElement('input', _extends({ ref: function ref(el) {
          _this.$input = el;
        } }, inputAttribute, { max: max, min: min, autoFocus: autoFocus, type: type, defaultValue: value, maxLength: maxLength, readOnly: readOnly, disabled: disabled, placeholder: placeholder, onChange: _this.onChange, onBlur: _this.onBlur, onFocus: _this.onFocus, className: 'input-text' + (inputAttribute.className ? ' ' + inputAttribute.className : '') }));
    };

    _this.updateShowClear = function (value) {
      var _this$props8 = _this.props,
          readOnly = _this$props8.readOnly,
          disabled = _this$props8.disabled,
          clear = _this$props8.clear,
          valueBindProp = _this$props8.valueBindProp;

      if (valueBindProp) return;
      if (readOnly || disabled || !clear) {
        _this.setState({
          showClear: false
        });
        return;
      }
      var showClear = false;
      if (value) {
        showClear = true;
      } else {
        showClear = false;
      }
      _this.setState({
        showClear: showClear
      });
    };

    _this.state = {
      showClear: props.value && props.clear && !props.readOnly && !props.disabled // 用于非valueBindProp
    };
    return _this;
  }
  // 解决非valueBindProp状态下, readOnly和disabled发生变化时, 不更新清除按钮的问题

  // 点击容器

  // 自动扩充功能

  // 文本框事件

  // 点击清除

  // 非valueBindProp时, 更新清除按钮状态


  InputText.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        type = _props.type,
        valueBindProp = _props.valueBindProp,
        pre = _props.pre,
        onClick = _props.onClick,
        _props$inputAttribute = _props.inputAttribute,
        inputAttribute = _props$inputAttribute === undefined ? {} : _props$inputAttribute,
        autoFocus = _props.autoFocus,
        maxLength = _props.maxLength,
        max = _props.max,
        min = _props.min,
        digits = _props.digits,
        readOnly = _props.readOnly,
        disabled = _props.disabled,
        value = _props.value,
        placeholder = _props.placeholder,
        onChange = _props.onChange,
        onBlur = _props.onBlur,
        onFocus = _props.onFocus,
        liconAttribute = _props.liconAttribute,
        licon = _props.licon,
        riconAttribute = _props.riconAttribute,
        ricon = _props.ricon,
        clear = _props.clear,
        _props$clearAttribute = _props.clearAttribute,
        clearAttribute = _props$clearAttribute === undefined ? {} : _props$clearAttribute,
        rcaption = _props.rcaption,
        othres = _objectWithoutProperties(_props, ['type', 'valueBindProp', 'pre', 'onClick', 'inputAttribute', 'autoFocus', 'maxLength', 'max', 'min', 'digits', 'readOnly', 'disabled', 'value', 'placeholder', 'onChange', 'onBlur', 'onFocus', 'liconAttribute', 'licon', 'riconAttribute', 'ricon', 'clear', 'clearAttribute', 'rcaption']);
    // 支持valueBindProp和非valueBindProp两种模式的清空按钮控制


    var showClear = false;
    if (value && !readOnly && !disabled) {
      showClear = true;
    } else {
      showClear = false;
    }
    var isShowClear = valueBindProp ? showClear : this.state.showClear;
    return _react2.default.createElement(
      'div',
      _extends({ ref: function ref(el) {
          _this2.$el = el;
        } }, othres, { className: 'input-text-box' + (othres.className ? ' ' + othres.className : ''), onClick: this.onClick }),
      licon && licon,
      liconAttribute && liconAttribute.className && _react2.default.createElement('i', _extends({}, liconAttribute, { className: 'icon' + (liconAttribute.className ? ' ' + liconAttribute.className : '') })),
      this.getInputDOM(),
      clear && _react2.default.createElement('i', _extends({}, clearAttribute, { className: 'icon clearicon' + (isShowClear ? '' : ' hide') + (clearAttribute.className ? ' ' + clearAttribute.className : ' ricon close-icon-clear size18') })),
      riconAttribute && riconAttribute.className && _react2.default.createElement('i', _extends({}, riconAttribute, { className: 'icon' + (riconAttribute.className ? ' ' + riconAttribute.className : '') })),
      ricon && ricon,
      rcaption && rcaption
    );
  };

  return InputText;
}(_react.Component), _class.defaultProps = {
  type: 'text',
  value: '',
  readOnly: false,
  disabled: false
}, _temp);
exports.default = InputText;
InputText.propTypes = process.env.NODE_ENV !== "production" ? {
  type: _propTypes2.default.string, // 类型: text | number | tel | password
  valueBindProp: _propTypes2.default.bool, // 值是否绑定属性
  pre: _propTypes2.default.bool, // 自动扩充功能
  // 容器
  onClick: _propTypes2.default.func,
  // 文本框
  inputAttribute: _propTypes2.default.object,
  autoFocus: _propTypes2.default.bool,
  maxLength: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  max: _propTypes2.default.oneOfType([// 日期或者数字框
  _propTypes2.default.string, _propTypes2.default.number]),
  min: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  digits: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.string, _propTypes2.default.number]),
  readOnly: _propTypes2.default.bool,
  disabled: _propTypes2.default.bool,

  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  placeholder: _propTypes2.default.string,
  // 文本框事件
  onChange: _propTypes2.default.func,
  onBlur: _propTypes2.default.func,
  onFocus: _propTypes2.default.func,
  // 左右图标
  liconAttribute: _propTypes2.default.bool,
  licon: _propTypes2.default.node,
  riconAttribute: _propTypes2.default.bool,
  ricon: _propTypes2.default.node,
  // 清除按键
  clear: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.func]),
  clearAttribute: _propTypes2.default.object,
  // 右侧内容
  rcaption: _propTypes2.default.node
} : {};
module.exports = exports['default'];